﻿/// <reference path="jquery.js" />
/// <reference path="sha256.js" />

var connectionString = "Endpoint=sb://nozapp-ns.servicebus.windows.net/;SharedAccessKeyName=DefaultFullSharedAccessSignature;SharedAccessKey=12mGnI9MTSWmv4ODZ/0tYl5D6aq+yXZ2FiNOm+W8fYI=";
var hubname = "NOZAPP";

var parts = connectionString.split(';');
if (parts.length != 3) {
    throw "Error parsing connection string";
}

var endpoint;
var sasKeyName;
var sasKeyValue;

$(parts).each(function (part) {
    if (part.indexOf('Endpoint') == 0) {
        endpoint = 'https' + part.substring(11);
    } else if (part.indexOf('SharedAccessKeyName') == 0) {
        sasKeyName = part.substring(20);
    } else if (part.indexOf('SharedAccessKey') == 0) {
        sasKeyValue = part.substring(16);
    }
});

var hub = {
    hubPath: hubname,
    endpoint: endpoint
};

var getSelfSignedToken = function (targetUri, sharedKey, ruleId, expiresInMins) {
    targetUri = encodeURIComponent(targetUri.toLowerCase()).toLowerCase();

    // Set expiration in seconds
    var expireOnDate = new Date();
    expireOnDate.setMinutes(expireOnDate.getMinutes() + expiresInMins);
    var expires = Date.UTC(expireOnDate.getUTCFullYear(), expireOnDate
    .getUTCMonth(), expireOnDate.getUTCDate(), expireOnDate
    .getUTCHours(), expireOnDate.getUTCMinutes(), expireOnDate
    .getUTCSeconds()) / 1000;
    var tosign = targetUri + '\n' + expires;

    // using CryptoJS
    var signature = CryptoJS.HmacSHA256(tosign, sharedKey);
    var base64signature = signature.toString(CryptoJS.enc.Base64);
    var base64UriEncoded = encodeURIComponent(base64signature);

    // construct autorization string
    var token = "SharedAccessSignature sr=" + targetUri + "&sig="
    + base64UriEncoded + "&se=" + expires + "&skn=" + ruleId;
    // console.log("signature:" + token);
    return token;
};

var createRegistrationId = function () {
    var registrationPath = hub.hubPath + "/Registrations";
    var serverUrl = hub.endpoint + registrationPath + "?api-version=2013-08";

    var token = getSelfSignedToken(serverUrl, sasKeyValue, sasKeyName, 60);

    var deferred = $.Deferred();
    $.ajax({
        type: "POST",
        url: serverUrl,
        headers: {
            "Authorization": token
        },
    }).done(function (data, status, response) {
        var location = response.getResponseHeader("Content-Location");
        deferred.resolve(location);
    }).fail(function (response, status, error) {
        console.log("Error: " + error);
        deferred.reject("Error: " + error);
    });

    return deferred.promise();
};

var updateRegistration = function (location, registration) {
    var registrationPayload = buildCreatePayload(registration);
    var serverUrl = location;

    var token = getSelfSignedToken(serverUrl, sasKeyValue, sasKeyName, 60);

    var deferred = $.Deferred();

    return $.ajax({
        type: "PUT",
        url: serverUrl,
        headers: {
            "Content-Type": "application/atom+xml",
            "Authorization": token,
        },
        data: registrationPayload
    })
        .done(function (data, status, response) {
            var location = response.getResponseHeader("Content-Location");
            deferred.resolve(location);
        })
        .fail(function (response, status, error) {
            console.log("Error: " + error);
            deferred.reject("Error: " + error);
        });

    return deferred.promise();
};

